Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDao.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDao.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDao.cs	(revision 4649)
@@ -8,63 +8,78 @@
   using DT = HeuristicLab.Services.Hive.Common.DataTransfer;
   using HeuristicLab.Services.Hive.Common.DataTransfer;
+  using HeuristicLab.Services.Hive.DataAccess.Properties;
 
   public class HiveDao : IHiveDao {
-    private IContextFactory<HiveDataContext> contextFactory;
-    private DataAccess.HiveDataContext db { get { return contextFactory.CurrentContext; } }
-
-    public HiveDao(IContextFactory<HiveDataContext> contextFactory) {
-      this.contextFactory = contextFactory;
+    public HiveDataContext CreateContext() {
+      return new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
+    }
+
+    public HiveDao() {
     }
 
     #region Job Methods
     public DT.Job GetJob(Guid id) {
-      return Convert.ToDto(db.Jobs.SingleOrDefault(x => x.JobId == id));
+      using (var db = CreateContext()) {
+        return Convert.ToDto(db.Jobs.SingleOrDefault(x => x.JobId == id));
+      }
     }
 
     public IEnumerable<DT.Job> GetJobs(Expression<Func<Job, bool>> predicate) {
-      return db.Jobs.Where(predicate).Select(x => Convert.ToDto(x));
+      using (var db = CreateContext()) {
+        return db.Jobs.Where(predicate).Select(x => Convert.ToDto(x)).ToArray();
+      }
     }
 
     public Guid AddJob(DT.Job dto) {
-      var entity = Convert.ToEntity(dto);
-      db.Jobs.InsertOnSubmit(entity);
-      db.SubmitChanges();
-      return entity.JobId;
+      using (var db = CreateContext()) {
+        var entity = Convert.ToEntity(dto);
+        db.Jobs.InsertOnSubmit(entity);
+        db.SubmitChanges();
+        return entity.JobId;
+      }
     }
 
     public void UpdateJob(DT.Job dto) {
-      var entity = db.Jobs.FirstOrDefault(x => x.JobId == dto.Id);
-      if (entity == null) db.Jobs.InsertOnSubmit(Convert.ToEntity(dto));
-      else Convert.ToEntity(dto, entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.Jobs.FirstOrDefault(x => x.JobId == dto.Id);
+        if (entity == null) db.Jobs.InsertOnSubmit(Convert.ToEntity(dto));
+        else Convert.ToEntity(dto, entity);
+        db.SubmitChanges();
+      }
     }
 
     public void DeleteJob(Guid id) {
-      var entity = db.Jobs.FirstOrDefault(x => x.JobId == id);
-      if (entity != null) db.Jobs.DeleteOnSubmit(entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.Jobs.FirstOrDefault(x => x.JobId == id);
+        if (entity != null) db.Jobs.DeleteOnSubmit(entity);
+        db.SubmitChanges();
+      }
     }
 
     public IEnumerable<DT.Job> GetAvailableParentJobs(Guid slaveId) {
-      // todo: slaveId is unused!
-      var query = from ar in db.AssignedResources
-                  where ar.Job.JobState == JobState.WaitForChildJobs &&
-                    (from child in db.Jobs
-                     where child.ParentJobId == ar.Job.JobId
-                     select child.JobState == JobState.Finished).All(x => x) &&
-                    (from child in db.Jobs // avoid returning WaitForChildJobs jobs where no child-jobs exist (yet)
-                     where child.ParentJobId == ar.Job.JobId
-                     select child).Count() > 0
-                  orderby ar.Job.Priority descending
-                  select Convert.ToDto(ar.Job);
-      return query;
+      using (var db = CreateContext()) {
+        // todo: slaveId is unused!
+        var query = from ar in db.AssignedResources
+                    where ar.Job.JobState == JobState.WaitingForChildJobs &&
+                      (from child in db.Jobs
+                       where child.ParentJobId == ar.Job.JobId
+                       select child.JobState == JobState.Finished).All(x => x) &&
+                      (from child in db.Jobs // avoid returning WaitForChildJobs jobs where no child-jobs exist (yet)
+                       where child.ParentJobId == ar.Job.JobId
+                       select child).Count() > 0
+                    orderby ar.Job.Priority descending
+                    select Convert.ToDto(ar.Job);
+        return query;
+      }
     }
 
     public IEnumerable<DT.Job> GetAvailableJobs(DT.Slave slave) {
-      var query = from j in db.Jobs
-                  where j.JobState == JobState.Waiting && j.CoresNeeded <= slave.FreeCores && j.MemoryNeeded <= slave.FreeMemory
-                  orderby j.Priority descending
-                  select Convert.ToDto(j);
-      return query.Union(GetAvailableParentJobs(slave.Id)).OrderByDescending(x => x.Priority).ToArray();
+      using (var db = CreateContext()) {
+        var query = from j in db.Jobs
+                    where j.JobState == JobState.Waiting && j.CoresNeeded <= slave.FreeCores && j.MemoryNeeded <= slave.FreeMemory
+                    orderby j.Priority descending
+                    select Convert.ToDto(j);
+        return query.Union(GetAvailableParentJobs(slave.Id)).OrderByDescending(x => x.Priority).ToArray();
+      }
     }
     #endregion
@@ -73,29 +88,39 @@
 
     public DT.JobData GetJobData(Guid id) {
-      return Convert.ToDto(db.JobDatas.SingleOrDefault(x => x.JobId == id));
+      using (var db = CreateContext()) {
+        return Convert.ToDto(db.JobDatas.SingleOrDefault(x => x.JobId == id));
+      }
     }
 
     public IEnumerable<DT.JobData> GetJobDatas(Expression<Func<JobData, bool>> predicate) {
-      return db.JobDatas.Where(predicate).Select(x => Convert.ToDto(x));
+      using (var db = CreateContext()) {
+        return db.JobDatas.Where(predicate).Select(x => Convert.ToDto(x)).ToArray();
+      }
     }
 
     public Guid AddJobData(DT.JobData dto) {
-      var entity = Convert.ToEntity(dto);
-      db.JobDatas.InsertOnSubmit(entity);
-      db.SubmitChanges();
-      return entity.JobId;
+      using (var db = CreateContext()) {
+        var entity = Convert.ToEntity(dto);
+        db.JobDatas.InsertOnSubmit(entity);
+        db.SubmitChanges();
+        return entity.JobId;
+      }
     }
 
     public void UpdateJobData(DT.JobData dto) {
-      var entity = db.JobDatas.FirstOrDefault(x => x.JobId == dto.Id);
-      if (entity == null) db.JobDatas.InsertOnSubmit(Convert.ToEntity(dto));
-      else Convert.ToEntity(dto, entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.JobDatas.FirstOrDefault(x => x.JobId == dto.JobId);
+        if (entity == null) db.JobDatas.InsertOnSubmit(Convert.ToEntity(dto));
+        else Convert.ToEntity(dto, entity);
+        db.SubmitChanges();
+      }
     }
 
     public void DeleteJobData(Guid id) {
-      var entity = db.JobDatas.FirstOrDefault(x => x.JobId == id); // check if all the byte[] is loaded into memory here. otherwise work around to delete without loading it
-      if (entity != null) db.JobDatas.DeleteOnSubmit(entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.JobDatas.FirstOrDefault(x => x.JobId == id); // check if all the byte[] is loaded into memory here. otherwise work around to delete without loading it
+        if (entity != null) db.JobDatas.DeleteOnSubmit(entity);
+        db.SubmitChanges();
+      }
     }
     #endregion
@@ -103,60 +128,79 @@
     #region HiveExperiment Methods
     public DT.HiveExperiment GetHiveExperiment(Guid id) {
-      return Convert.ToDto(db.HiveExperiments.SingleOrDefault(x => x.HiveExperimentId == id));
+      using (var db = CreateContext()) {
+        return Convert.ToDto(db.HiveExperiments.SingleOrDefault(x => x.HiveExperimentId == id));
+      }
     }
 
     public IEnumerable<DT.HiveExperiment> GetHiveExperiments(Expression<Func<HiveExperiment, bool>> predicate) {
-      return db.HiveExperiments.Where(predicate).Select(x => Convert.ToDto(x));
+      using (var db = CreateContext()) {
+        return db.HiveExperiments.Where(predicate).Select(x => Convert.ToDto(x)).ToArray();
+      }
     }
 
     public Guid AddHiveExperiment(DT.HiveExperiment dto) {
-      var entity = Convert.ToEntity(dto);
-      db.HiveExperiments.InsertOnSubmit(entity);
-      db.SubmitChanges();
-      return entity.HiveExperimentId;
+      using (var db = CreateContext()) {
+        var entity = Convert.ToEntity(dto);
+        db.HiveExperiments.InsertOnSubmit(entity);
+        db.SubmitChanges();
+        return entity.HiveExperimentId;
+      }
     }
 
     public void UpdateHiveExperiment(DT.HiveExperiment dto) {
-      var entity = db.HiveExperiments.FirstOrDefault(x => x.HiveExperimentId == dto.Id);
-      if (entity == null) db.HiveExperiments.InsertOnSubmit(Convert.ToEntity(dto));
-      else Convert.ToEntity(dto, entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.HiveExperiments.FirstOrDefault(x => x.HiveExperimentId == dto.Id);
+        if (entity == null) db.HiveExperiments.InsertOnSubmit(Convert.ToEntity(dto));
+        else Convert.ToEntity(dto, entity);
+        db.SubmitChanges();
+      }
     }
 
     public void DeleteHiveExperiment(Guid id) {
-      var entity = db.HiveExperiments.FirstOrDefault(x => x.HiveExperimentId == id);
-      if (entity != null) db.HiveExperiments.DeleteOnSubmit(entity);
-      db.SubmitChanges();
-    }
-    #endregion
-
+      using (var db = CreateContext()) {
+        var entity = db.HiveExperiments.FirstOrDefault(x => x.HiveExperimentId == id);
+        if (entity != null) db.HiveExperiments.DeleteOnSubmit(entity);
+        db.SubmitChanges();
+      }
+    }
+    #endregion
 
     #region Slave Methods
     public DT.Slave GetSlave(Guid id) {
-      return Convert.ToDto(db.Resources.OfType<Slave>().SingleOrDefault(x => x.ResourceId == id));
+      using (var db = CreateContext()) {
+        return Convert.ToDto(db.Resources.OfType<Slave>().SingleOrDefault(x => x.ResourceId == id));
+      }
     }
 
     public IEnumerable<DT.Slave> GetSlaves(Expression<Func<Slave, bool>> predicate) {
-      return db.Resources.OfType<Slave>().Where(predicate).Select(x => Convert.ToDto(x));
+      using (var db = CreateContext()) {
+        return db.Resources.OfType<Slave>().Where(predicate).Select(x => Convert.ToDto(x)).ToArray();
+      }
     }
 
     public Guid AddSlave(DT.Slave dto) {
-      var entity = Convert.ToEntity(dto);
-      db.Resources.InsertOnSubmit(entity);
-      db.SubmitChanges();
-      return entity.ResourceId;
+      using (var db = CreateContext()) {
+        var entity = Convert.ToEntity(dto);
+        db.Resources.InsertOnSubmit(entity);
+        db.SubmitChanges();
+        return entity.ResourceId;
+      }
     }
 
     public void UpdateSlave(DT.Slave dto) {
-      var entity = db.Resources.OfType<Slave>().FirstOrDefault(x => x.ResourceId == dto.Id);
-      if (entity == null) db.Resources.InsertOnSubmit(Convert.ToEntity(dto));
-      else Convert.ToEntity(dto, entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.Resources.OfType<Slave>().FirstOrDefault(x => x.ResourceId == dto.Id);
+        if (entity == null) db.Resources.InsertOnSubmit(Convert.ToEntity(dto));
+        else Convert.ToEntity(dto, entity);
+        db.SubmitChanges();
+      }
     }
 
     public void DeleteSlave(Guid id) {
-      var entity = db.Resources.OfType<Slave>().FirstOrDefault(x => x.ResourceId == id);
-      if (entity != null) db.Resources.DeleteOnSubmit(entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.Resources.OfType<Slave>().FirstOrDefault(x => x.ResourceId == id);
+        if (entity != null) db.Resources.DeleteOnSubmit(entity);
+        db.SubmitChanges();
+      }
     }
     #endregion
@@ -164,29 +208,39 @@
     #region SlaveGroup Methods
     public DT.SlaveGroup GetSlaveGroup(Guid id) {
-      return Convert.ToDto(db.Resources.OfType<SlaveGroup>().SingleOrDefault(x => x.ResourceId == id));
+      using (var db = CreateContext()) {
+        return Convert.ToDto(db.Resources.OfType<SlaveGroup>().SingleOrDefault(x => x.ResourceId == id));
+      }
     }
 
     public IEnumerable<DT.SlaveGroup> GetSlaveGroups(Expression<Func<SlaveGroup, bool>> predicate) {
-      return db.Resources.OfType<SlaveGroup>().Where(predicate).Select(x => Convert.ToDto(x));
+      using (var db = CreateContext()) {
+        return db.Resources.OfType<SlaveGroup>().Where(predicate).Select(x => Convert.ToDto(x)).ToArray();
+      }
     }
 
     public Guid AddSlaveGroup(DT.SlaveGroup dto) {
-      var entity = Convert.ToEntity(dto);
-      db.Resources.InsertOnSubmit(entity);
-      db.SubmitChanges();
-      return entity.ResourceId;
+      using (var db = CreateContext()) {
+        var entity = Convert.ToEntity(dto);
+        db.Resources.InsertOnSubmit(entity);
+        db.SubmitChanges();
+        return entity.ResourceId;
+      }
     }
 
     public void UpdateSlaveGroup(DT.SlaveGroup dto) {
-      var entity = db.Resources.OfType<SlaveGroup>().FirstOrDefault(x => x.ResourceId == dto.Id);
-      if (entity == null) db.Resources.InsertOnSubmit(Convert.ToEntity(dto));
-      else Convert.ToEntity(dto, entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.Resources.OfType<SlaveGroup>().FirstOrDefault(x => x.ResourceId == dto.Id);
+        if (entity == null) db.Resources.InsertOnSubmit(Convert.ToEntity(dto));
+        else Convert.ToEntity(dto, entity);
+        db.SubmitChanges();
+      }
     }
 
     public void DeleteSlaveGroup(Guid id) {
-      var entity = db.Resources.OfType<SlaveGroup>().FirstOrDefault(x => x.ResourceId == id);
-      if (entity != null) db.Resources.DeleteOnSubmit(entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.Resources.OfType<SlaveGroup>().FirstOrDefault(x => x.ResourceId == id);
+        if (entity != null) db.Resources.DeleteOnSubmit(entity);
+        db.SubmitChanges();
+      }
     }
     #endregion
@@ -194,29 +248,39 @@
     #region Resource Methods
     public DT.Resource GetResource(Guid id) {
-      return Convert.ToDto(db.Resources.SingleOrDefault(x => x.ResourceId == id));
+      using (var db = CreateContext()) {
+        return Convert.ToDto(db.Resources.SingleOrDefault(x => x.ResourceId == id));
+      }
     }
 
     public IEnumerable<DT.Resource> GetResources(Expression<Func<Resource, bool>> predicate) {
-      return db.Resources.Where(predicate).Select(x => Convert.ToDto(x));
+      using (var db = CreateContext()) {
+        return db.Resources.Where(predicate).Select(x => Convert.ToDto(x)).ToArray();
+      }
     }
 
     public Guid AddResource(DT.Resource dto) {
-      var entity = Convert.ToEntity(dto);
-      db.Resources.InsertOnSubmit(entity);
-      db.SubmitChanges();
-      return entity.ResourceId;
+      using (var db = CreateContext()) {
+        var entity = Convert.ToEntity(dto);
+        db.Resources.InsertOnSubmit(entity);
+        db.SubmitChanges();
+        return entity.ResourceId;
+      }
     }
 
     public void UpdateResource(DT.Resource dto) {
-      var entity = db.Resources.FirstOrDefault(x => x.ResourceId == dto.Id);
-      if (entity == null) db.Resources.InsertOnSubmit(Convert.ToEntity(dto));
-      else Convert.ToEntity(dto, entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.Resources.FirstOrDefault(x => x.ResourceId == dto.Id);
+        if (entity == null) db.Resources.InsertOnSubmit(Convert.ToEntity(dto));
+        else Convert.ToEntity(dto, entity);
+        db.SubmitChanges();
+      }
     }
 
     public void DeleteResource(Guid id) {
-      var entity = db.Resources.FirstOrDefault(x => x.ResourceId == id);
-      if (entity != null) db.Resources.DeleteOnSubmit(entity);
-      db.SubmitChanges();
+      using (var db = CreateContext()) {
+        var entity = db.Resources.FirstOrDefault(x => x.ResourceId == id);
+        if (entity != null) db.Resources.DeleteOnSubmit(entity);
+        db.SubmitChanges();
+      }
     }
     #endregion
@@ -224,12 +288,12 @@
     #region Authorization Methods
     public bool IsUserAuthorizedForJobs(Guid userId, params Guid[] jobIds) {
-      var userIds = from job in db.Jobs // this needs to be fast!
-                    where jobIds.Contains(job.JobId)
-                    select job.UserId;
-      return userIds.All(x => x == userId);
-    }
-    #endregion
-
-
+      using (var db = CreateContext()) {
+        var userIds = from job in db.Jobs // this needs to be fast!
+                      where jobIds.Contains(job.JobId)
+                      select job.UserId;
+        return userIds.All(x => x == userId);
+      }
+    }
+    #endregion
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 4649)
@@ -70,13 +70,13 @@
       <Association Name="Resource_UptimeCalendar" Member="UptimeCalendars" ThisKey="ResourceId" OtherKey="ResourceId" Type="UptimeCalendar" />
       <Type Name="Slave" InheritanceCode="Slave" IsInheritanceDefault="true">
-        <Column Name="CPUSpeed" Type="System.Int32" DbType="Int" CanBeNull="true" />
+        <Column Name="CpuSpeed" Storage="_CPUSpeed" Type="System.Int32" DbType="Int" CanBeNull="true" />
         <Column Name="Memory" Type="System.Int32" DbType="Int" CanBeNull="true" />
         <Column Name="Login" Type="System.DateTime" DbType="DateTime" CanBeNull="true" />
-        <Column Name="Status" Type="System.String" DbType="VarChar(MAX)" CanBeNull="true" />
-        <Column Name="CalendarSyncStatus" Type="System.String" DbType="VarChar(MAX)" CanBeNull="true" />
+        <Column Name="SlaveState" Storage="_Status" Type="global::HeuristicLab.Services.Hive.Common.DataTransfer.SlaveState" DbType="VarChar(15)" CanBeNull="true" />
+        <Column Name="CalendarSyncState" Storage="_CalendarSyncStatus" Type="global::HeuristicLab.Services.Hive.Common.DataTransfer.CalendarState" DbType="VarChar(MAX)" CanBeNull="true" />
         <Column Name="UseCalendarFromResourceId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="true" />
         <Column Name="SlaveConfigId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="true" />
-        <Column Name="NumberOfCores" Type="System.Int32" DbType="Int" CanBeNull="true" />
-        <Column Name="NumberOfFreeCores" Type="System.Int32" DbType="Int" CanBeNull="true" />
+        <Column Name="Cores" Storage="_NumberOfCores" Type="System.Int32" DbType="Int" CanBeNull="true" />
+        <Column Name="FreeCores" Storage="_NumberOfFreeCores" Type="System.Int32" DbType="Int" CanBeNull="true" />
         <Column Name="FreeMemory" Type="System.Int32" DbType="Int" CanBeNull="true" />
         <Column Name="IsAllowedToCalculate" Type="System.Boolean" DbType="Bit" CanBeNull="false" />
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 4649)
@@ -1569,7 +1569,7 @@
 		private System.Nullable<System.DateTime> _Login;
 		
-		private string _Status;
-		
-		private string _CalendarSyncStatus;
+		private global::HeuristicLab.Services.Hive.Common.DataTransfer.SlaveState _Status;
+		
+		private global::HeuristicLab.Services.Hive.Common.DataTransfer.CalendarState _CalendarSyncStatus;
 		
 		private System.Nullable<System.Guid> _UseCalendarFromResourceId;
@@ -1595,22 +1595,22 @@
     partial void OnValidate(System.Data.Linq.ChangeAction action);
     partial void OnCreated();
-    partial void OnCPUSpeedChanging(System.Nullable<int> value);
-    partial void OnCPUSpeedChanged();
+    partial void OnCpuSpeedChanging(System.Nullable<int> value);
+    partial void OnCpuSpeedChanged();
     partial void OnMemoryChanging(System.Nullable<int> value);
     partial void OnMemoryChanged();
     partial void OnLoginChanging(System.Nullable<System.DateTime> value);
     partial void OnLoginChanged();
-    partial void OnStatusChanging(string value);
-    partial void OnStatusChanged();
-    partial void OnCalendarSyncStatusChanging(string value);
-    partial void OnCalendarSyncStatusChanged();
+    partial void OnSlaveStateChanging(global::HeuristicLab.Services.Hive.Common.DataTransfer.SlaveState value);
+    partial void OnSlaveStateChanged();
+    partial void OnCalendarSyncStateChanging(global::HeuristicLab.Services.Hive.Common.DataTransfer.CalendarState value);
+    partial void OnCalendarSyncStateChanged();
     partial void OnUseCalendarFromResourceIdChanging(System.Nullable<System.Guid> value);
     partial void OnUseCalendarFromResourceIdChanged();
     partial void OnSlaveConfigIdChanging(System.Nullable<System.Guid> value);
     partial void OnSlaveConfigIdChanged();
-    partial void OnNumberOfCoresChanging(System.Nullable<int> value);
-    partial void OnNumberOfCoresChanged();
-    partial void OnNumberOfFreeCoresChanging(System.Nullable<int> value);
-    partial void OnNumberOfFreeCoresChanged();
+    partial void OnCoresChanging(System.Nullable<int> value);
+    partial void OnCoresChanged();
+    partial void OnFreeCoresChanging(System.Nullable<int> value);
+    partial void OnFreeCoresChanged();
     partial void OnFreeMemoryChanging(System.Nullable<int> value);
     partial void OnFreeMemoryChanged();
@@ -1628,5 +1628,5 @@
 		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CPUSpeed", DbType="Int")]
-		public System.Nullable<int> CPUSpeed
+		public System.Nullable<int> CpuSpeed
 		{
 			get
@@ -1638,9 +1638,9 @@
 				if ((this._CPUSpeed != value))
 				{
-					this.OnCPUSpeedChanging(value);
+					this.OnCpuSpeedChanging(value);
 					this.SendPropertyChanging();
 					this._CPUSpeed = value;
-					this.SendPropertyChanged("CPUSpeed");
-					this.OnCPUSpeedChanged();
+					this.SendPropertyChanged("CpuSpeed");
+					this.OnCpuSpeedChanged();
 				}
 			}
@@ -1687,6 +1687,6 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Status", DbType="VarChar(MAX)")]
-		public string Status
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Status", DbType="VarChar(15)", CanBeNull=true)]
+		public global::HeuristicLab.Services.Hive.Common.DataTransfer.SlaveState SlaveState
 		{
 			get
@@ -1698,15 +1698,15 @@
 				if ((this._Status != value))
 				{
-					this.OnStatusChanging(value);
+					this.OnSlaveStateChanging(value);
 					this.SendPropertyChanging();
 					this._Status = value;
-					this.SendPropertyChanged("Status");
-					this.OnStatusChanged();
-				}
-			}
-		}
-		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CalendarSyncStatus", DbType="VarChar(MAX)")]
-		public string CalendarSyncStatus
+					this.SendPropertyChanged("SlaveState");
+					this.OnSlaveStateChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CalendarSyncStatus", DbType="VarChar(MAX)", CanBeNull=true)]
+		public global::HeuristicLab.Services.Hive.Common.DataTransfer.CalendarState CalendarSyncState
 		{
 			get
@@ -1718,9 +1718,9 @@
 				if ((this._CalendarSyncStatus != value))
 				{
-					this.OnCalendarSyncStatusChanging(value);
+					this.OnCalendarSyncStateChanging(value);
 					this.SendPropertyChanging();
 					this._CalendarSyncStatus = value;
-					this.SendPropertyChanged("CalendarSyncStatus");
-					this.OnCalendarSyncStatusChanged();
+					this.SendPropertyChanged("CalendarSyncState");
+					this.OnCalendarSyncStateChanged();
 				}
 			}
@@ -1772,5 +1772,5 @@
 		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_NumberOfCores", DbType="Int")]
-		public System.Nullable<int> NumberOfCores
+		public System.Nullable<int> Cores
 		{
 			get
@@ -1782,9 +1782,9 @@
 				if ((this._NumberOfCores != value))
 				{
-					this.OnNumberOfCoresChanging(value);
+					this.OnCoresChanging(value);
 					this.SendPropertyChanging();
 					this._NumberOfCores = value;
-					this.SendPropertyChanged("NumberOfCores");
-					this.OnNumberOfCoresChanged();
+					this.SendPropertyChanged("Cores");
+					this.OnCoresChanged();
 				}
 			}
@@ -1792,5 +1792,5 @@
 		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_NumberOfFreeCores", DbType="Int")]
-		public System.Nullable<int> NumberOfFreeCores
+		public System.Nullable<int> FreeCores
 		{
 			get
@@ -1802,9 +1802,9 @@
 				if ((this._NumberOfFreeCores != value))
 				{
-					this.OnNumberOfFreeCoresChanging(value);
+					this.OnFreeCoresChanging(value);
 					this.SendPropertyChanging();
 					this._NumberOfFreeCores = value;
-					this.SendPropertyChanged("NumberOfFreeCores");
-					this.OnNumberOfFreeCoresChanged();
+					this.SendPropertyChanged("FreeCores");
+					this.OnFreeCoresChanged();
 				}
 			}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Tools/CreateHiveDatabaseApplication.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Tools/CreateHiveDatabaseApplication.cs	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Tools/CreateHiveDatabaseApplication.cs	(revision 4649)
@@ -27,11 +27,9 @@
 
     public override void Run() {
-      CreateDataContext<HiveDataContext> contextCreator = new CreateDataContext<HiveDataContext>(ContextFactory<HiveDataContext>.CreateHiveContext);
-      IContextFactory<HiveDataContext> contextFactory = new ContextFactory<HiveDataContext>(contextCreator);
-
-      using (contextFactory.GetContext(false)) {
-        if (contextFactory.CurrentContext.DatabaseExists())
-          contextFactory.CurrentContext.DeleteDatabase();
-        contextFactory.CurrentContext.CreateDatabase();
+      var dao = new HiveDao();
+      using (var db = dao.CreateContext()) {
+        if (db.DatabaseExists())
+          db.DeleteDatabase();
+        db.CreateDatabase();
       }
     }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/TransactionManager.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/TransactionManager.cs	(revision 4649)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/TransactionManager.cs	(revision 4649)
@@ -0,0 +1,23 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Services.Hive.Common;
+using System.Transactions;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Services.Hive.DataAccess {
+  public class TransactionManager {
+    public Disposable<TransactionScope> OpenTransaction() {
+      TransactionScope transaction = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE });
+      var disposable = new Disposable<TransactionScope>(transaction);
+      disposable.Disposing += disposable_Disposing;
+      return disposable;
+    }
+
+    void disposable_Disposing(object sender, EventArgs<TransactionScope> scope) {
+      scope.Value.Complete();
+      scope.Value.Dispose();
+    }
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/MergeConfigs.cmd
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/MergeConfigs.cmd	(revision 4629)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/MergeConfigs.cmd	(revision 4649)
@@ -6,5 +6,5 @@
 copy "%SolutionDir%HeuristicLab 3.3.exe.config" "%TargetDir%"
 
-%SolutionDir%ConfigMerger "%SolutionDir%HeuristicLab.Hive-3.3.dll.config" "HeuristicLab 3.3.exe.config"
-
-copy "HeuristicLab 3.3.exe.config" "%target%"
+%SolutionDir%ConfigMerger "%TargetDir%HeuristicLab.Hive-3.3.dll.config" "%TargetDir%HeuristicLab 3.3.exe.config"
+copy "%TargetDir%HeuristicLab 3.3.exe.config" "asdf.config"
+copy "%TargetDir%HeuristicLab 3.3.exe.config" "%target%"
